##
##  UCS / The R ToolBox
##

## Filename: ucs.R
## Modified: Mon Mar 29 21:31:49 2004 (evert)   
##   Author: Stefan Evert
##  Purpose: UCS configuration and loader routines

ucs.basedir <- '/home/evert/UCS/System'	 # in-place edit by Install.perl
ucs.cygwin <- FALSE	 # in-place edit by Install.perl
ucs.R.dir <- paste(ucs.basedir, "R", sep="/")
ucs.R.lib <- paste(ucs.R.dir, "lib", sep="/")

## load UCS/R library (from UCS/R lib directory)
##   ucs.library(name)
## name = name of library (without extension, e.g. "plots")
## NB libraries may be re-loaded by calling ucs.library() repeatedly; in contrast
## NB to the built-in library() function, UCS/R does not check whether a library
## NB has already been loaded
##   ucs.library()
## lists available UCS/R libraries with short description; returns a list with the
## library names as keys; the list is blessed into class UCSLibList (for display)
ucs.library <- function (name) {
  libs <- list(base="AM registry and some basic functions for UCS data sets",
               plots="graphs for the evaluation of association measures",
               sfunc="some special functions (gamma, beta, confidence intervals)",
               lexstats="graphs for lexical statistics, interface to lexstats software",
               zm="the Zipf-Mandelbrot LNRE model",
               fzm="the finite Zipf-Mandelbrot LNRE model")
  if (missing(name)) {
    class(libs) <- "UCSLibList"
    return(libs)
  } else {
    if (! name %in% names(libs)) stop("The UCS/R library '", name, "' does not exist.")
    filename <- paste(ucs.R.lib, "/", name, ".R", sep="")
    source(filename)
  }
}

print.UCSLibList <- function (l) {
  names <- format(names(l))
  for (i in 1:length(l)) {
    cat(names[i], l[[i]], "\n")
  }
}
